package org.agt.module.license.service.customer;

import jakarta.validation.Valid;
import org.agt.framework.common.pojo.PageResult;
import org.agt.module.license.controller.admin.customer.vo.CustomerImportRespVO;
import org.agt.module.license.controller.admin.customer.vo.CustomerPageReqVO;
import org.agt.module.license.controller.admin.customer.vo.CustomerRespVO;
import org.agt.module.license.controller.admin.customer.vo.CustomerSaveReqVO;
import org.agt.module.license.controller.admin.customer.vo.DashboardRespVO;
import org.agt.module.license.controller.admin.license.vo.ImportRespVO;
import org.agt.module.license.dal.dataobject.customer.CustomerDO;

import java.util.List;

/**
 * 客户 Service 接口
 *
 * @author 管理员
 */
public interface CustomerService {

    DashboardRespVO dashboard();

    /**
     * 创建客户
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCustomer(@Valid CustomerSaveReqVO createReqVO);

    /**
     * 更新客户
     *
     * @param updateReqVO 更新信息
     */
    void updateCustomer(@Valid CustomerSaveReqVO updateReqVO);

    /**
     * 删除客户
     *
     * @param id 编号
     */
    void deleteCustomer(Long id);

    /**
     * 获得客户
     *
     * @param id 编号
     * @return 客户
     */
    CustomerDO getCustomer(Long id);

    /**
     * 获得客户分页
     *
     * @param pageReqVO 分页查询
     * @return 客户分页
     */
    PageResult<CustomerDO> getCustomerPage(CustomerPageReqVO pageReqVO);

    /**
     * 获得客户列表
     *
     * @return 客户分页
     */
    List<CustomerDO> getCustomerList();

    /**
     * 校验客户名称是否唯一
     *
     * @param name 客户名称
     * @param id   客户id
     * @return 是否存在
     */
    Boolean validateCustomerNameUnique(String name, Long id);

    /**
     * 校验客户编号是否唯一
     *
     * @param code 客户编号
     * @param id   客户id
     * @return 是否存在
     */
    Boolean validateCustomerCodeUnique(String code, Long id);

    /**
     * 查询当前最大的sn号
     *
     * @return 最大sn号
     */
    Integer selectMaxCode();

    ImportRespVO importList(List<CustomerImportRespVO> list, Boolean updateSupport);

    List<CustomerRespVO> getLicenseCustomers();
}